]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test-lib.sh: add test_valid_json
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # STDIN from /dev/null. EOF for readers (and ENOTTY for tty related ioctls).
59 exec </dev/null
60
61 # Save STDOUT to fd 6 and STDERR to fd 7.
62 exec 6>&1 7>&2
63 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
64 BASH_XTRACEFD=7
65 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
66
67 # Keep the original TERM for say_color and test_emacs
68 ORIGINAL_TERM=$TERM
69
70 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
71 # Otherwise use whatever TERM is currently used so that
72 # users' actual TERM environments are being used in tests.
73 case ${TERM-} in
74         '' | dumb | unknown )
75                 SMART_TERM=vt100 ;;
76         *)
77                 SMART_TERM=$TERM ;;
78 esac
79
80 # For repeatability, reset the environment to known value.
81 LANG=C
82 LC_ALL=C
83 PAGER=cat
84 TZ=UTC
85 TERM=dumb
86 export LANG LC_ALL PAGER TERM TZ
87 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
88 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
89       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
90     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
91     exit 1
92 fi
93 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
94 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
95 TEST_GDB=${TEST_GDB:-gdb}
96 TEST_CC=${TEST_CC:-cc}
97 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
98 TEST_SHIM_CFLAGS=${TEST_SHIM_CFLAGS:-"-fpic -shared"}
99 TEST_SHIM_LDFLAGS=${TEST_SHIM_LDFLAGS:-"-ldl"}
100
101 # Protect ourselves from common misconfiguration to export
102 # CDPATH into the environment
103 unset CDPATH
104
105 unset GREP_OPTIONS
106
107 # For emacsclient
108 unset ALTERNATE_EDITOR
109
110 add_gnupg_home ()
111 {
112     local output
113     [ -e "${GNUPGHOME}/gpg.conf" ] && return
114     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
115     at_exit_function _gnupg_exit
116     mkdir -p -m 0700 "$GNUPGHOME"
117     gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
118     test_debug "cat $GNUPGHOME/import.log"
119     if (gpg --quick-random --version >/dev/null 2>&1) ; then
120         echo quick-random >> "$GNUPGHOME"/gpg.conf
121     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
122         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
123     fi
124     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
125
126     # Change this if we ship a new test key
127     FINGERPRINT="5AEAB11F5E33DCE875DDB75B6D92612D94E46381"
128     SELF_USERID="Notmuch Test Suite <test_suite@notmuchmail.org> (INSECURE!)"
129     printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
130 }
131
132 add_gpgsm_home ()
133 {
134     local fpr
135     [ -e "$GNUPGHOME/gpgsm.conf" ] && return
136     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
137     at_exit_function _gnupg_exit
138     mkdir -p -m 0700 "$GNUPGHOME"
139     openssl pkcs12 -export -passout pass: -inkey "$NOTMUCH_SRCDIR/test/smime/key+cert.pem" \
140         < "$NOTMUCH_SRCDIR/test/smime/test.crt" | \
141         gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
142               --disable-dirmngr --import  >"$GNUPGHOME"/import.log 2>&1 3<<<''
143     fpr=$(gpgsm --batch --list-key test_suite@notmuchmail.org | sed -n 's/.*fingerprint: //p')
144     echo "$fpr S relax" >> "$GNUPGHOME/trustlist.txt"
145     gpgsm --quiet --batch --no-tty --no-common-certs-import --disable-dirmngr --import < $NOTMUCH_SRCDIR/test/smime/ca.crt
146     echo "4D:E0:FF:63:C0:E9:EC:01:29:11:C8:7A:EE:DA:3A:9A:7F:6E:C1:0D S" >> "$GNUPGHOME/trustlist.txt"
147     echo include-certs::1 | gpgconf --output /dev/null --change-options gpgsm
148     gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
149               --disable-dirmngr --import "$NOTMUCH_SRCDIR/test/smime/bob.p12" >>"$GNUPGHOME"/import.log 2>&1 3<<<''
150     test_debug "cat $GNUPGHOME/import.log"
151 }
152
153 # Each test should start with something like this, after copyright notices:
154 #
155 # test_description='Description of this test...
156 # This test checks if command xyzzy does the right thing...
157 # '
158 # . ./test-lib.sh || exit 1
159
160 color=maybe
161
162 while test "$#" -ne 0
163 do
164         case "$1" in
165         -d|--debug)
166                 debug=t; shift ;;
167         -i|--immediate)
168                 immediate=t; shift ;;
169         -h|--help)
170                 help=t; shift ;;
171         -v|--verbose)
172                 verbose=t; shift ;;
173         -q|--quiet)
174                 quiet=t; shift ;;
175         --with-dashes)
176                 with_dashes=t; shift ;;
177         --no-color)
178                 color=; shift ;;
179         --no-python)
180                 # noop now...
181                 shift ;;
182         --valgrind)
183                 valgrind=t; verbose=t; shift ;;
184         --tee)
185                 shift ;; # was handled already
186         *)
187                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
188         esac
189 done
190
191 if test -n "$debug"; then
192     print_subtest () {
193         printf " %-4s" "[$((test_count - 1))]"
194     }
195 else
196     print_subtest () {
197         true
198     }
199 fi
200
201 test -n "$COLORS_WITHOUT_TTY" || [ -t 1 ] || color=
202
203 if [ -n "$color" ] && [ "$ORIGINAL_TERM" != 'dumb' ] && (
204                 TERM=$ORIGINAL_TERM &&
205                 export TERM &&
206                 tput bold
207                 tput setaf
208                 tput sgr0
209         ) >/dev/null 2>&1
210 then
211         color=t
212 else
213         color=
214 fi
215
216 if test -n "$color"; then
217         say_color () {
218                 (
219                 TERM=$ORIGINAL_TERM
220                 export TERM
221                 case "$1" in
222                         error) tput bold; tput setaf 1;; # bold red
223                         skip)  tput bold; tput setaf 2;; # bold green
224                         pass)  tput setaf 2;;            # green
225                         info)  tput setaf 3;;            # brown
226                         *) test -n "$quiet" && return;;
227                 esac
228                 shift
229                 printf " "
230                 printf "$@"
231                 tput sgr0
232                 print_subtest
233                 )
234         }
235 else
236         say_color() {
237                 test -z "$1" && test -n "$quiet" && return
238                 shift
239                 printf " "
240                 printf "$@"
241                 print_subtest
242         }
243 fi
244
245 error () {
246         say_color error "error: $*\n"
247         GIT_EXIT_OK=t
248         exit 1
249 }
250
251 say () {
252         say_color info "$*"
253 }
254
255 test "${test_description}" != "" ||
256 error "Test script did not set test_description."
257
258 if test "$help" = "t"
259 then
260         echo "Tests ${test_description}"
261         exit 0
262 fi
263
264 test_description_printed=
265 print_test_description ()
266 {
267         test -z "$test_description_printed" || return 0
268         echo
269         echo $this_test: "Testing ${test_description}"
270         test_description_printed=1
271 }
272 if [ -z "$NOTMUCH_TEST_QUIET" ]
273 then
274         print_test_description
275 fi
276
277 test_failure=0
278 test_count=0
279 test_fixed=0
280 test_broken=0
281 test_success=0
282
283 declare -a _exit_functions=()
284
285 at_exit_function () {
286         _exit_functions=($1 ${_exit_functions[@]/$1})
287 }
288
289 rm_exit_function () {
290         _exit_functions=(${_exit_functions[@]/$1})
291 }
292
293 _exit_common () {
294         code=$?
295         trap - EXIT
296         set +ex
297         for _fn in ${_exit_functions[@]}; do $_fn; done
298         rm -rf "$TEST_TMPDIR"
299 }
300
301 trap_exit () {
302         _exit_common
303         if test -n "$GIT_EXIT_OK"
304         then
305                 exit $code
306         else
307                 exec >&6
308                 say_color error '%-6s' FATAL
309                 echo " $test_subtest_name"
310                 echo
311                 echo "Unexpected exit while executing $0. Exit code $code."
312                 exit 1
313         fi
314 }
315
316 trap_signal () {
317         _exit_common
318         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
319         exit $code
320 }
321
322 die () {
323         _exit_common
324         exec >&6
325         say_color error '%-6s' FATAL
326         echo " $*"
327         echo
328         echo "Unexpected exit while executing $0."
329         exit 1
330 }
331
332 GIT_EXIT_OK=
333 # Note: TEST_TMPDIR *NOT* exported!
334 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
335 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
336 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
337 trap 'trap_exit' EXIT
338 trap 'trap_signal' HUP INT TERM
339
340 # Deliver a message with emacs and add it to the database
341 #
342 # Uses emacs to generate and deliver a message to the mail store.
343 # Accepts arbitrary extra emacs/elisp functions to modify the message
344 # before sending, which is useful to doing things like attaching files
345 # to the message and encrypting/signing.
346 emacs_deliver_message ()
347 {
348     local subject="$1"
349     local body="$2"
350     shift 2
351     # before we can send a message, we have to prepare the FCC maildir
352     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
353     # eval'ing smtp-dummy --background will set smtp_dummy_pid and -_port
354     local smtp_dummy_pid= smtp_dummy_port=
355     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
356     test -n "$smtp_dummy_pid" || return 1
357     test -n "$smtp_dummy_port" || return 1
358
359     test_emacs \
360         "(let ((message-send-mail-function 'message-smtpmail-send-it)
361                (mail-host-address \"example.com\")
362                (smtpmail-smtp-server \"localhost\")
363                (smtpmail-smtp-service \"${smtp_dummy_port}\"))
364            (notmuch-mua-mail)
365            (message-goto-to)
366            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
367            (message-goto-subject)
368            (insert \"${subject}\")
369            (message-goto-body)
370            (insert \"${body}\")
371            $*
372            (notmuch-mua-send-and-exit))"
373
374     # In case message was sent properly, client waits for confirmation
375     # before exiting and resuming control here; therefore making sure
376     # that server exits by sending (KILL) signal to it is safe.
377     kill -9 $smtp_dummy_pid
378     notmuch new >/dev/null
379 }
380
381 # Pretend to deliver a message with emacs. Really save it to a file
382 # and add it to the database
383 #
384 # Uses emacs to generate and deliver a message to the mail store.
385 # Accepts arbitrary extra emacs/elisp functions to modify the message
386 # before sending, which is useful to doing things like attaching files
387 # to the message and encrypting/signing.
388 #
389 # If any GNU-style long-arguments (like --quiet or --decrypt=true) are
390 # at the head of the argument list, they are sent directly to "notmuch
391 # new" after message delivery
392 emacs_fcc_message ()
393 {
394     local nmn_args=''
395     while [[ "$1" =~ ^-- ]]; do
396         nmn_args="$nmn_args $1"
397         shift
398     done
399     local subject="$1"
400     local body="$2"
401     shift 2
402     # before we can send a message, we have to prepare the FCC maildir
403     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
404
405     test_emacs \
406         "(let ((message-send-mail-function (lambda () t))
407                (mail-host-address \"example.com\"))
408            (notmuch-mua-mail)
409            (message-goto-to)
410            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
411            (message-goto-subject)
412            (insert \"${subject}\")
413            (message-goto-body)
414            (insert \"${body}\")
415            $*
416            (notmuch-mua-send-and-exit))" || return 1
417     notmuch new $nmn_args >/dev/null
418 }
419
420 # Add an existing, fixed corpus of email to the database.
421 #
422 # $1 is the corpus dir under corpora to add, using "default" if unset.
423 #
424 # The default corpus is based on about 50 messages from early in the
425 # history of the notmuch mailing list, which allows for reliably
426 # testing commands that need to operate on a not-totally-trivial
427 # number of messages.
428 add_email_corpus ()
429 {
430     corpus=${1:-default}
431
432     rm -rf ${MAIL_DIR}
433     cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
434     notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
435 }
436
437 test_begin_subtest ()
438 {
439     if [ -n "$inside_subtest" ]; then
440         exec 1>&6 2>&7          # Restore stdout and stderr
441         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
442     fi
443     test_subtest_name="$1"
444     test_reset_state_
445     # Redirect test output to the previously prepared file descriptors
446     # 3 and 4 (see below)
447     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
448     exec >&3 2>&4
449     inside_subtest=t
450 }
451
452 # Pass test if two arguments match
453 #
454 # Note: Unlike all other test_expect_* functions, this function does
455 # not accept a test name. Instead, the caller should call
456 # test_begin_subtest before calling this function in order to set the
457 # name.
458 test_expect_equal ()
459 {
460         exec 1>&6 2>&7          # Restore stdout and stderr
461         if [ -z "$inside_subtest" ]; then
462                 error "bug in the test script: test_expect_equal without test_begin_subtest"
463         fi
464         inside_subtest=
465         test "$#" = 2 ||
466         error "bug in the test script: not 2 parameters to test_expect_equal"
467
468         output="$1"
469         expected="$2"
470         if ! test_skip "$test_subtest_name"
471         then
472                 if [ "$output" = "$expected" ]; then
473                         test_ok_
474                 else
475                         testname=$this_test.$test_count
476                         echo "$expected" > $testname.expected
477                         echo "$output" > $testname.output
478                         test_failure_ "$(diff -u $testname.expected $testname.output)"
479                 fi
480     fi
481 }
482
483 # Like test_expect_equal, but takes two filenames.
484 test_expect_equal_file ()
485 {
486         exec 1>&6 2>&7          # Restore stdout and stderr
487         if [ -z "$inside_subtest" ]; then
488                 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
489         fi
490         inside_subtest=
491         test "$#" = 2 ||
492         error "bug in the test script: not 2 parameters to test_expect_equal_file"
493
494         file1="$1"
495         file2="$2"
496         if ! test_skip "$test_subtest_name"
497         then
498                 if diff -q "$file1" "$file2" >/dev/null ; then
499                         test_ok_
500                 else
501                         testname=$this_test.$test_count
502                         basename1=`basename "$file1"`
503                         basename2=`basename "$file2"`
504                         cp "$file1" "$testname.$basename1"
505                         cp "$file2" "$testname.$basename2"
506                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
507                 fi
508     fi
509 }
510
511 # Like test_expect_equal, but arguments are JSON expressions to be
512 # canonicalized before diff'ing.  If an argument cannot be parsed, it
513 # is used unchanged so that there's something to diff against.
514 test_expect_equal_json () {
515     # The test suite forces LC_ALL=C, but this causes Python 3 to
516     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
517     # override Python's stdio encoding defaults.
518     local script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
519     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
520         || echo "$1")
521     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
522         || echo "$2")
523     shift 2
524     test_expect_equal "$output" "$expected" "$@"
525 }
526
527 # Ensure that the argument is valid JSON data.
528 test_valid_json () {
529     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "import sys, json; json.load(sys.stdin)" <<<"$1"
530     test_expect_equal "$?" 0
531 }
532
533 # Sort the top-level list of JSON data from stdin.
534 test_sort_json () {
535     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
536         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
537 }
538
539 # test for json objects:
540 # read the source of test/json_check_nodes.py (or the output when
541 # invoking it without arguments) for an explanation of the syntax.
542 test_json_nodes () {
543         exec 1>&6 2>&7          # Restore stdout and stderr
544         if [ -z "$inside_subtest" ]; then
545                 error "bug in the test script: test_json_eval without test_begin_subtest"
546         fi
547         inside_subtest=
548         test "$#" > 0 ||
549             error "bug in the test script: test_json_nodes needs at least 1 parameter"
550
551         if ! test_skip "$test_subtest_name"
552         then
553             output=$(PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON "$TEST_DIRECTORY"/json_check_nodes.py "$@")
554                 if [ "$?" = 0 ]
555                 then
556                         test_ok_
557                 else
558                         test_failure_ "$output"
559                 fi
560         fi
561 }
562
563 test_emacs_expect_t () {
564         test "$#" = 1 ||
565         error "bug in the test script: not 1 parameter to test_emacs_expect_t"
566         if [ -z "$inside_subtest" ]; then
567                 error "bug in the test script: test_emacs_expect_t without test_begin_subtest"
568         fi
569
570         # Run the test.
571         if ! test_skip "$test_subtest_name"
572         then
573                 test_emacs "(notmuch-test-run $1)" >/dev/null
574
575                 # Restore state after the test.
576                 exec 1>&6 2>&7          # Restore stdout and stderr
577                 inside_subtest=
578
579                 # Report success/failure.
580                 result=$(cat OUTPUT)
581                 if [ "$result" = t ]
582                 then
583                         test_ok_
584                 else
585                         test_failure_ "${result}"
586                 fi
587         else
588                 # Restore state after the (non) test.
589                 exec 1>&6 2>&7          # Restore stdout and stderr
590                 inside_subtest=
591         fi
592 }
593
594 NOTMUCH_NEW ()
595 {
596     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
597 }
598
599 NOTMUCH_DUMP_TAGS ()
600 {
601     # this relies on the default format being batch-tag, otherwise some tests will break
602     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
603 }
604
605 notmuch_drop_mail_headers ()
606 {
607     $NOTMUCH_PYTHON -c '
608 import email, sys
609 msg = email.message_from_file(sys.stdin)
610 for hdr in sys.argv[1:]: del msg[hdr]
611 print(msg.as_string(False))
612 ' "$@"
613 }
614
615 notmuch_search_sanitize ()
616 {
617     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
618 }
619
620 notmuch_search_files_sanitize ()
621 {
622     notmuch_dir_sanitize
623 }
624
625 notmuch_dir_sanitize ()
626 {
627     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
628 }
629
630 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
631 notmuch_show_sanitize ()
632 {
633     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
634 }
635 notmuch_show_sanitize_all ()
636 {
637     sed \
638         -e 's| filename:.*| filename:XXXXX|' \
639         -e 's| id:[^ ]* | id:XXXXX |' | \
640         notmuch_date_sanitize
641 }
642
643 notmuch_json_show_sanitize ()
644 {
645     sed \
646         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
647         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
648         -e 's|"filename": "signature.asc",||g' \
649         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
650         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
651         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
652 }
653
654 notmuch_emacs_error_sanitize ()
655 {
656     local command=$1
657     shift
658     for file in "$@"; do
659         echo "=== $file ==="
660         cat "$file"
661     done | sed  \
662         -e 's/^\[.*\]$/[XXX]/' \
663         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
664 }
665
666 notmuch_date_sanitize ()
667 {
668     sed \
669         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
670 }
671
672 notmuch_uuid_sanitize ()
673 {
674     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
675 }
676
677 notmuch_built_with_sanitize ()
678 {
679     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
680 }
681
682 notmuch_config_sanitize ()
683 {
684     notmuch_dir_sanitize | notmuch_built_with_sanitize
685 }
686
687 notmuch_show_part ()
688 {
689     awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
690 }
691
692 # End of notmuch helper functions
693
694 # Use test_set_prereq to tell that a particular prerequisite is available.
695 #
696 # The prerequisite can later be checked for by using test_have_prereq.
697 #
698 # The single parameter is the prerequisite tag (a simple word, in all
699 # capital letters by convention).
700
701 test_set_prereq () {
702         satisfied="$satisfied$1 "
703 }
704 satisfied=" "
705
706 test_have_prereq () {
707         case $satisfied in
708         *" $1 "*)
709                 : yes, have it ;;
710         *)
711                 ! : nope ;;
712         esac
713 }
714
715 declare -A test_missing_external_prereq_
716 declare -A test_subtest_missing_external_prereq_
717
718 # declare prerequisite for the given external binary
719 test_declare_external_prereq () {
720         binary="$1"
721         test "$#" = 2 && name=$2 || name="$binary(1)"
722
723         if ! hash $binary 2>/dev/null; then
724                 test_missing_external_prereq_["${binary}"]=t
725                 eval "
726 $binary () {
727         test_subtest_missing_external_prereq_[\"${name}\"]=t
728         false
729 }"
730         fi
731 }
732
733 # Explicitly require external prerequisite.  Useful when binary is
734 # called indirectly (e.g. from emacs).
735 # Returns success if dependency is available, failure otherwise.
736 test_require_external_prereq () {
737         binary="$1"
738         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
739                 # dependency is missing, call the replacement function to note it
740                 eval "$binary"
741         else
742                 true
743         fi
744 }
745
746 # You are not expected to call test_ok_ and test_failure_ directly, use
747 # the text_expect_* functions instead.
748
749 test_ok_ () {
750         if test "$test_subtest_known_broken_" = "t"; then
751                 test_known_broken_ok_
752                 return
753         fi
754         test_success=$(($test_success + 1))
755         if test -n "$NOTMUCH_TEST_QUIET"; then
756                 return 0
757         fi
758         say_color pass "%-6s" "PASS"
759         echo " $test_subtest_name"
760 }
761
762 test_failure_ () {
763         print_test_description
764         if test "$test_subtest_known_broken_" = "t"; then
765                 test_known_broken_failure_ "$@"
766                 return
767         fi
768         test_failure=$(($test_failure + 1))
769         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
770         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
771         return 1
772 }
773
774 test_failure_message_ () {
775         say_color error "%-6s" "$1"
776         echo " $2"
777         shift 2
778         if [ "$#" != "0" ]; then
779                 echo "$@" | sed -e 's/^/        /'
780         fi
781         if test "$verbose" != "t"; then cat test.output; fi
782 }
783
784 test_known_broken_ok_ () {
785         test_reset_state_
786         test_fixed=$(($test_fixed+1))
787         say_color pass "%-6s" "FIXED"
788         echo " $test_subtest_name"
789 }
790
791 test_known_broken_failure_ () {
792         test_reset_state_
793         test_broken=$(($test_broken+1))
794         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
795                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
796         else
797                 test_failure_message_ "BROKEN" "$test_subtest_name"
798         fi
799         return 1
800 }
801
802 test_debug () {
803         test "$debug" = "" || eval "$1"
804 }
805
806 test_run_ () {
807         test_cleanup=:
808         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
809         eval >&3 2>&4 "$1"
810         eval_ret=$?
811         eval >&3 2>&4 "$test_cleanup"
812         return 0
813 }
814
815 test_skip () {
816         test_count=$(($test_count+1))
817         to_skip=
818         for skp in $NOTMUCH_SKIP_TESTS
819         do
820                 case $this_test.$test_count in
821                 $skp)
822                         to_skip=t
823                         break
824                 esac
825                 case $this_test_bare.$test_count in
826                 $skp)
827                         to_skip=t
828                         break
829                 esac
830         done
831         case "$to_skip" in
832         t)
833                 test_report_skip_ "$@"
834                 ;;
835         *)
836                 test_check_missing_external_prereqs_ "$@"
837                 ;;
838         esac
839 }
840
841 test_check_missing_external_prereqs_ () {
842         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
843                 say_color skip >&1 "missing prerequisites: "
844                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
845                 test_report_skip_ "$@"
846         else
847                 false
848         fi
849 }
850
851 test_report_skip_ () {
852         test_reset_state_
853         say_color skip >&3 "skipping test:"
854         echo " $@" >&3
855         say_color skip "%-6s" "SKIP"
856         echo " $1"
857 }
858
859 test_subtest_known_broken () {
860         test_subtest_known_broken_=t
861 }
862
863 test_expect_success () {
864         exec 1>&6 2>&7          # Restore stdout and stderr
865         if [ -z "$inside_subtest" ]; then
866                 error "bug in the test script: test_expect_success without test_begin_subtest"
867         fi
868         inside_subtest=
869         test "$#" = 1 ||
870         error "bug in the test script: not 1 parameters to test_expect_success"
871
872         if ! test_skip "$test_subtest_name"
873         then
874                 test_run_ "$1"
875                 run_ret="$?"
876                 # test_run_ may update missing external prerequisites
877                 test_check_missing_external_prereqs_ "$@" ||
878                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
879                 then
880                         test_ok_
881                 else
882                         test_failure_ "$1"
883                 fi
884         fi
885 }
886
887 test_expect_code () {
888         exec 1>&6 2>&7          # Restore stdout and stderr
889         if [ -z "$inside_subtest" ]; then
890                 error "bug in the test script: test_expect_code without test_begin_subtest"
891         fi
892         inside_subtest=
893         test "$#" = 2 ||
894         error "bug in the test script: not 2 parameters to test_expect_code"
895
896         if ! test_skip "$test_subtest_name"
897         then
898                 test_run_ "$2"
899                 run_ret="$?"
900                 # test_run_ may update missing external prerequisites,
901                 test_check_missing_external_prereqs_ "$@" ||
902                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
903                 then
904                         test_ok_
905                 else
906                         test_failure_ "exit code $eval_ret, expected $1" "$2"
907                 fi
908         fi
909 }
910
911 # This is not among top-level (test_expect_success)
912 # but is a prefix that can be used in the test script, like:
913 #
914 #       test_expect_success 'complain and die' '
915 #           do something &&
916 #           do something else &&
917 #           test_must_fail git checkout ../outerspace
918 #       '
919 #
920 # Writing this as "! git checkout ../outerspace" is wrong, because
921 # the failure could be due to a segv.  We want a controlled failure.
922
923 test_must_fail () {
924         "$@"
925         test $? -gt 0 -a $? -le 129 -o $? -gt 192
926 }
927
928 # test_cmp is a helper function to compare actual and expected output.
929 # You can use it like:
930 #
931 #       test_expect_success 'foo works' '
932 #               echo expected >expected &&
933 #               foo >actual &&
934 #               test_cmp expected actual
935 #       '
936 #
937 # This could be written as either "cmp" or "diff -u", but:
938 # - cmp's output is not nearly as easy to read as diff -u
939 # - not all diff versions understand "-u"
940
941 test_cmp() {
942         $GIT_TEST_CMP "$@"
943 }
944
945 # This function can be used to schedule some commands to be run
946 # unconditionally at the end of the test to restore sanity:
947 #
948 #       test_expect_success 'test core.capslock' '
949 #               git config core.capslock true &&
950 #               test_when_finished "git config --unset core.capslock" &&
951 #               hello world
952 #       '
953 #
954 # That would be roughly equivalent to
955 #
956 #       test_expect_success 'test core.capslock' '
957 #               git config core.capslock true &&
958 #               hello world
959 #               git config --unset core.capslock
960 #       '
961 #
962 # except that the greeting and config --unset must both succeed for
963 # the test to pass.
964
965 test_when_finished () {
966         test_cleanup="{ $*
967                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
968 }
969
970 test_done () {
971         GIT_EXIT_OK=t
972         test_results_dir="$TEST_DIRECTORY/test-results"
973         mkdir -p "$test_results_dir"
974         test_results_path="$test_results_dir/$this_test"
975
976         echo "total $test_count" >> $test_results_path
977         echo "success $test_success" >> $test_results_path
978         echo "fixed $test_fixed" >> $test_results_path
979         echo "broken $test_broken" >> $test_results_path
980         echo "failed $test_failure" >> $test_results_path
981         echo "" >> $test_results_path
982
983         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
984
985         if [ "$test_failure" = "0" ]; then
986             if [ "$test_broken" = "0" ]; then
987                 rm -rf "$remove_tmp"
988             fi
989             exit 0
990         else
991             exit 1
992         fi
993 }
994
995 emacs_generate_script () {
996         # Construct a little test script here for the benefit of the user,
997         # (who can easily run "run_emacs" to get the same emacs environment
998         # for investigating any failures).
999         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
1000 #!/bin/sh
1001 export PATH=$PATH
1002 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
1003
1004 # Here's what we are using here:
1005 #
1006 # --quick              Use minimal customization. This implies --no-init-file,
1007 #                      --no-site-file and (emacs 24) --no-site-lisp
1008 #
1009 # --directory           Ensure that the local elisp sources are found
1010 #
1011 # --load                Force loading of notmuch.el and test-lib.el
1012
1013 exec ${TEST_EMACS} --quick \
1014         --directory "$NOTMUCH_SRCDIR/emacs" --load notmuch.el \
1015         --directory "$NOTMUCH_SRCDIR/test" --load test-lib.el \
1016         "\$@"
1017 EOF
1018         chmod a+x "$TMP_DIRECTORY/run_emacs"
1019 }
1020
1021 test_emacs () {
1022         # test dependencies beforehand to avoid the waiting loop below
1023         missing_dependencies=
1024         test_require_external_prereq dtach || missing_dependencies=1
1025         test_require_external_prereq emacs || missing_dependencies=1
1026         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
1027         test -z "$missing_dependencies" || return
1028
1029         if [ -z "$EMACS_SERVER" ]; then
1030                 emacs_tests="$NOTMUCH_SRCDIR/test/${this_test_bare}.el"
1031                 if [ -f "$emacs_tests" ]; then
1032                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
1033                 else
1034                         load_emacs_tests=
1035                 fi
1036                 server_name="notmuch-test-suite-$$"
1037                 # start a detached session with an emacs server
1038                 # user's TERM (or 'vt100' in case user's TERM is known dumb
1039                 # or unknown) is given to dtach which assumes a minimally
1040                 # VT100-compatible terminal -- and emacs inherits that
1041                 TERM=$SMART_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
1042                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
1043                                 --no-window-system \
1044                                 $load_emacs_tests \
1045                                 --eval '(setq server-name \"$server_name\")' \
1046                                 --eval '(server-start)' \
1047                                 --eval '(orphan-watchdog $$)'" || return
1048                 EMACS_SERVER="$server_name"
1049                 # wait until the emacs server is up
1050                 until test_emacs '()' >/dev/null 2>/dev/null; do
1051                         sleep 1
1052                 done
1053         fi
1054
1055         # Clear test-output output file.  Most Emacs tests end with a
1056         # call to (test-output).  If the test code fails with an
1057         # exception before this call, the output file won't get
1058         # updated.  Since we don't want to compare against an output
1059         # file from another test, so start out with an empty file.
1060         rm -f OUTPUT
1061         touch OUTPUT
1062
1063         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $*)"
1064 }
1065
1066 test_python() {
1067     # Note: if there is need to print debug information from python program,
1068     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
1069     PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
1070         $NOTMUCH_PYTHON -B - > OUTPUT
1071 }
1072
1073 test_ruby() {
1074     MAIL_DIR=$MAIL_DIR $NOTMUCH_RUBY -I $NOTMUCH_SRCDIR/bindings/ruby> OUTPUT
1075 }
1076
1077 test_C () {
1078     exec_file="test${test_count}"
1079     test_file="${exec_file}.c"
1080     cat > ${test_file}
1081     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
1082     echo "== stdout ==" > OUTPUT.stdout
1083     echo "== stderr ==" > OUTPUT.stderr
1084     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1085     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr > OUTPUT
1086 }
1087
1088 make_shim () {
1089     base_name="$1"
1090     test_file="${base_name}.c"
1091     shim_file="${base_name}.so"
1092     cat > ${test_file}
1093     ${TEST_CC} ${TEST_CFLAGS} ${TEST_SHIM_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${shim_file} ${test_file} ${TEST_SHIM_LDFLAGS}
1094 }
1095
1096 notmuch_with_shim () {
1097     base_name="$1"
1098     shift
1099     shim_file="${base_name}.so"
1100     LD_PRELOAD=./${shim_file}${LD_PRELOAD:+:$LD_PRELOAD} notmuch-shared "$@"
1101 }
1102
1103 # Creates a script that counts how much time it is executed and calls
1104 # notmuch.  $notmuch_counter_command is set to the path to the
1105 # generated script.  Use notmuch_counter_value() function to get the
1106 # current counter value.
1107 notmuch_counter_reset () {
1108         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1109         if [ ! -x "$notmuch_counter_command" ]; then
1110                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1111                 cat >"$notmuch_counter_command" <<EOF || return
1112 #!/bin/sh
1113
1114 read count < "$notmuch_counter_state_path"
1115 echo \$((count + 1)) > "$notmuch_counter_state_path"
1116
1117 exec notmuch "\$@"
1118 EOF
1119                 chmod +x "$notmuch_counter_command" || return
1120         fi
1121
1122         echo 0 > "$notmuch_counter_state_path"
1123 }
1124
1125 # Returns the current notmuch counter value.
1126 notmuch_counter_value () {
1127         if [ -r "$notmuch_counter_state_path" ]; then
1128                 read count < "$notmuch_counter_state_path"
1129         else
1130                 count=0
1131         fi
1132         echo $count
1133 }
1134
1135 test_reset_state_ () {
1136         test -z "$test_init_done_" && test_init_
1137
1138         test_subtest_known_broken_=
1139         test_subtest_missing_external_prereq_=()
1140 }
1141
1142 # called once before the first subtest
1143 test_init_ () {
1144         test_init_done_=t
1145
1146         # skip all tests if there were external prerequisites missing during init
1147         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1148 }
1149
1150
1151 # Where to run the tests
1152 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
1153
1154 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
1155
1156 emacs_generate_script
1157
1158
1159 # Use -P to resolve symlinks in our working directory so that the cwd
1160 # in subprocesses like git equals our $PWD (for pathname comparisons).
1161 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
1162
1163 if test "$verbose" = "t"
1164 then
1165         exec 4>&2 3>&1
1166 else
1167         exec 4>test.output 3>&4
1168 fi
1169
1170 for skp in $NOTMUCH_SKIP_TESTS
1171 do
1172         to_skip=
1173         for skp in $NOTMUCH_SKIP_TESTS
1174         do
1175                 case "$this_test" in
1176                 $skp)
1177                         to_skip=t
1178                         break
1179                 esac
1180                 case "$this_test_bare" in
1181                 $skp)
1182                         to_skip=t
1183                         break
1184                 esac
1185         done
1186         case "$to_skip" in
1187         t)
1188                 say_color skip >&3 "skipping test $this_test altogether"
1189                 say_color skip "skip all tests in $this_test"
1190                 test_done
1191         esac
1192 done
1193
1194 # Provide an implementation of the 'yes' utility
1195 yes () {
1196         if test $# = 0
1197         then
1198                 y=y
1199         else
1200                 y="$*"
1201         fi
1202
1203         while echo "$y"
1204         do
1205                 :
1206         done
1207 }
1208
1209 # Fix some commands on Windows
1210 case $(uname -s) in
1211 *MINGW*)
1212         # Windows has its own (incompatible) sort and find
1213         sort () {
1214                 /usr/bin/sort "$@"
1215         }
1216         find () {
1217                 /usr/bin/find "$@"
1218         }
1219         sum () {
1220                 md5sum "$@"
1221         }
1222         # git sees Windows-style pwd
1223         pwd () {
1224                 builtin pwd -W
1225         }
1226         # no POSIX permissions
1227         # backslashes in pathspec are converted to '/'
1228         # exec does not inherit the PID
1229         ;;
1230 *)
1231         test_set_prereq POSIXPERM
1232         test_set_prereq BSLASHPSPEC
1233         test_set_prereq EXECKEEPSPID
1234         ;;
1235 esac
1236
1237 test -z "$NO_PERL" && test_set_prereq PERL
1238 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1239
1240 # test whether the filesystem supports symbolic links
1241 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1242 rm -f y
1243
1244 # convert variable from configure to more convenient form
1245 case "$NOTMUCH_DEFAULT_XAPIAN_BACKEND" in
1246     glass)
1247         db_ending=glass
1248     ;;
1249     chert)
1250         db_ending=DB
1251     ;;
1252     *)
1253         error "Unknown Xapian backend $NOTMUCH_DEFAULT_XAPIAN_BACKEND"
1254 esac
1255 # declare prerequisites for external binaries used in tests
1256 test_declare_external_prereq dtach
1257 test_declare_external_prereq emacs
1258 test_declare_external_prereq ${TEST_EMACSCLIENT}
1259 test_declare_external_prereq ${TEST_GDB}
1260 test_declare_external_prereq gpg
1261 test_declare_external_prereq openssl
1262 test_declare_external_prereq gpgsm
1263 test_declare_external_prereq ${NOTMUCH_PYTHON}